/*
	$Id: Export.java 272 2006-08-19 22:38:42Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
*/
public class Export implements Compound {

    /** "struct" ޤ "union" ޤ "eunm" */
    private String type;

    /** ɥȤ˵ܤ뤳η̾ */
    private String descType;

    /** descǤ */
    private Description desc;

    /**
       ݡȤޤ

       @param gm 롼ץޥ͡
       @param elem export
    */
    public Export(final GroupManager gm, final Element elem) {
	type = elem.getAttribute("type");
	descType = type + " " + gm.expandNS(elem, "tag");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ɥȤ˵ܤ뤳η̾ޤ

       @return ɥȤ˵ܤ뤳η̾
    */
    public String getDescType() {
	return descType;
    }

    /**
       ݡȤΥפޤ

       @return "struct" ޤ "union" ޤ "eunm"

    */
    public String getType() {
	return type;
    }

    /**
       HTML˽Ϥե̾ޤ

       @param m ̻ҥޥ͡
       @return ե̾
    */
    private String getFieldName(final IDManager m) {
	return "<b>" + m.getString(descType) + "</b>";
    }

    /**
       HTMLξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    private String getFieldName() {
	return "<b>" + descType + "</b>";
    }

    /**
       TeXξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    private String getTexFieldName() {
	return descType;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	wr.println(descType + ";");
    }

    public final void printCompoundSummary(final PrintWriter wr) {
	IDManager m = IDManager.getInstance();
	String fieldName = getFieldName(m);

	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">\n"
+ "      <tr>\n"
+ "        <td colspan=\"2\"><font size=\"+1\">" + fieldName + "</font><br>\n"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "        </tr>\n"
+ "    </table><br>");
    }

    public final void printCompoundDetail(final PrintWriter wr) {
	String fieldName = getFieldName();

	wr.println(""
+ "<p><a name=\"" + descType + "\"></a>\n"
+ "<font size=\"+1\">" + fieldName + "</font></p>\n"
+ "<dl><dd>" + desc.getText()
+ "</dd></dl>\n"
+ "<hr>");
    }

    public final void printTexCompoundDetail(final PrintWriter wr) {
	String fieldName = Tex.safe(getTexFieldName());

	wr.println("\\Sid{" + fieldName + "}");
	wr.println(desc.getTexText());
    }
}
